﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Threading;

namespace WPF_Chart_Tooltips_BitmapMode
{
    public class DispatchService
    {
        private readonly Dispatcher _dispatcher;

        public DispatchService(Dispatcher dispatcher)
        {
            _dispatcher = dispatcher;
        }

        public bool CheckAccess()
        {
            return _dispatcher.CheckAccess();
        }

        public void BeginInvoke(Delegate method, params object[] args)
        {
            lock (_dispatcher)
            {
                _dispatcher.BeginInvoke(method, args);
            }
        }
        public void Invoke(Delegate method, params object[] args)
        {
            lock (_dispatcher)
            {
                _dispatcher.Invoke(method, args);
            }
        }
    }
}
